// Namespace
var android = {};
android.selection = {};

android.selection.selectionStartRange = null;
android.selection.selectionEndRange = null;

/** The last point touched by the user. { 'x': xPoint, 'y': yPoint } */
android.selection.lastTouchPoint = null;


/**
 * Starts the touch and saves the given x and y coordinates as last touch point
 */
android.selection.startTouch = function(x, y) {
    //android.selection.lastTouchPoint = {'x': x - ReadiumSDK.reader.getOffset().x,
    //'y': y - ReadiumSDK.reader.getOffset().y};
    android.selection.lastTouchPoint= {'x':x, 'y':y};
    console.debug("startTouch:x=" + x + ", y=" + y);
    //android.selection.clearSelection();
    //console.debug("startTouch:x=" + android.selection.lastTouchPoint.x + ", y=" + android.selection.lastTouchPoint.y);
};

android.selection.getDocument = function() {
    // ReadiumSDK.reader.getDocument()
    if (!android.selection.lastTouchPoint) {
        return null;
    }
    return ReadiumSDK.reader.getDocumentByPoint(android.selection.lastTouchPoint.x, android.selection.lastTouchPoint.y);
}
/**
 *  Checks to see if there is a selection.
 *
 *  @return boolean
 */
android.selection.hasSelection = function() {
    //return window.getSelection().toString().length > 0;
    return android.selection.getDocument().getSelection().toString().length > 0;
};

/**
 *  Clears the current selection.
 */
android.selection.clearSelection = function() {
    try {
        // if current selection clear it.
        window.getSelection().empty();
        //var sel = ReadiumSDK.reader.getDocument().getSelection();
        var sel = android.selection.getDocument().getSelection();
        sel.empty();
    }
    catch (e) {
        window.TextSelection.jsError(e);
    }
};

/**
 *  Handles the long touch action by selecting the last touched element.
 */
android.selection.longTouch = function() {
    //try {
        console.debug("longTouch");
        android.selection.clearSelection();

        var doc = android.selection.getDocument();
        var sel = doc.getSelection();
        var x = android.selection.lastTouchPoint.x;
        var y = android.selection.lastTouchPoint.y;

        var range = doc.caretRangeFromPoint(x, y);
        if (!range) {
            console.debug("range is empty!");
            return;
        }
        console.debug(range.startOffset + ',' + range.endOffset);
        range.expand("word");
        console.debug(range.toString());
        var text = range.toString();
        if (text.length == 1) {
            var baseKind = jpntext.kind(text);
            if (baseKind != jpntext.KIND['ascii']) {
                try {
                    do {
                        range.setEnd(range.endContainer, range.endOffset + 1);
                        text = range.toString();
                        var kind = jpntext.kind(text);
                    } while (baseKind == kind);
                    range.setEnd(range.endContainer, range.endOffset - 1);
                }
                catch (e) {
                }
                try {
                    do {
                        range.setStart(range.startContainer, range.startOffset - 1);
                        text = range.toString();
                        var kind = jpntext.kind(text);
                    } while (baseKind == kind);
                    range.setStart(range.startContainer, range.startOffset + 1);
                }
                catch (e) {
                }
            }
        }
        if (text.length > 0) {
            sel.removeAllRanges();
            sel.addRange(range);
            console.debug(range.toString());
            android.selection.saveSelectionStart();
            android.selection.saveSelectionEnd();
            android.selection.selectionChanged(true);
        } else {
            console.debug('no');
            sel.removeAllRanges();
        }
     //}
     //catch (err) {
      //  window.TextSelection.jsError(err);
     //}
};

/**
 * Tells the app to show the context menu.
 */
android.selection.selectionChanged = function(isReallyChanged) {
    //try {
        //var sel = window.getSelection();
        var doc = android.selection.getDocument();
        var sel = doc.getSelection();

        if (!sel) {
            return;
        }
        console.debug("selectionChanged");
        var range = sel.getRangeAt(0);


        //console.debug(sel.range);
//        console.debug(range.toString());
//        console.debug(range.startContainer + ','+ range.startOffset );
//        console.debug(range.endContainer + ','+ range.endOffset);
        var rects = range.getClientRects();
        var offset = ReadiumSDK.reader.getOffset();
        var i;
        for (i = 0; i < rects.length; ++i) {
            var rect = rects[i];
            console.debug("rect: left=" + rect.left + ", right=" + rect.right + ", top=" + rect.top + ", bottom=" + rect.bottom);
        }
        var handleBounds = "[{'left': " + (rects[0].left + offset.x) + ", ";
                handleBounds += "'top': " + (rects[0].top + offset.y) + ", ";
                handleBounds += "'right': " + (rects[0].right + offset.x) + ", ";
                handleBounds += "'bottom': " + (rects[0].bottom + offset.y) + "},";

                handleBounds += "{'left': " + (rects[rects.length-1].left + offset.x) + ", ";
                handleBounds += "'top': " + (rects[rects.length-1].top + offset.y) + ", ";
                handleBounds += "'right': " + (rects[rects.length-1].right + offset.x) + ", ";
                handleBounds += "'bottom': " + (rects[rects.length-1].bottom + offset.y) + "}]";

        var rangyRange = android.selection.getRange(sel);
        var text = sel.toString();
        //console.debug(text);
        // Set the content width
        window.TextSelection.setContentWidth(doc.body.clientWidth);
        // Tell the interface that the selection changed
        window.TextSelection.selectionChanged(rangyRange, text, handleBounds, isReallyChanged);
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

android.selection.getRange = function() {
    var serializedRangeSelected = rangy.serializeSelection();
    //console.debug("getRange");
    //console.debug(serializedRangeSelected);
    var serializerModule = rangy.modules.Serializer;
    if (serializedRangeSelected != '') {
        if (rangy.supported && serializerModule && serializerModule.supported) {
            var beginingCurly = serializedRangeSelected.indexOf("{");
            serializedRangeSelected = serializedRangeSelected.substring(0, beginingCurly);
            return serializedRangeSelected;
        }
    }
}

/**
 * Returns the last touch point as a readable string.
 */
android.selection.lastTouchPointString = function(){
    if (android.selection.lastTouchPoint == null)
        return "undefined";
    return "{" + android.selection.lastTouchPoint.x + "," + android.selection.lastTouchPoint.y + "}";
};

android.selection.saveSelectionStart = function(){
    //try {
        // Save the starting point of the selection
        //var sel = window.getSelection();
        var doc = android.selection.getDocument();
        var sel = doc.getSelection();
        var range = sel.getRangeAt(0);
        var saveRange = doc.createRange();
        saveRange.setStart(range.startContainer, range.startOffset);
        android.selection.selectionStartRange = saveRange;
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

android.selection.saveSelectionEnd = function(){
    //try {
        // Save the end point of the selection
        //var sel = window.getSelection();
        var doc = android.selection.getDocument();
        var sel = doc.getSelection();
        var range = sel.getRangeAt(0);
        var saveRange = doc.createRange();
        saveRange.setStart(range.endContainer, range.endOffset);
        android.selection.selectionEndRange = saveRange;
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

/**
 * Sets the last caret position for the start handle.
 */
android.selection.setStartPos = function(x, y){
    //try {
        var offset = ReadiumSDK.reader.getOffset();
        var doc = android.selection.getDocument();
        android.selection.selectBetweenHandles(
            doc.caretRangeFromPoint(x - offset.x, y - offset.y),
            android.selection.selectionEndRange);
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

/**
 * Sets the last caret position for the end handle.
 */
android.selection.setEndPos = function(x, y){
    //try {
        var doc = android.selection.getDocument();
        var offset = ReadiumSDK.reader.getOffset();
        android.selection.selectBetweenHandles(android.selection.selectionStartRange,
        doc.caretRangeFromPoint(x - offset.x, y - offset.y));
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

android.selection.restoreStartEndPos = function() {
    //try {
        android.selection.selectBetweenHandles(android.selection.selectionEndRange,
        android.selection.selectionStartRange);
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};

/**
 *  Selects all content between the two handles
 */
android.selection.selectBetweenHandles = function(startCaret, endCaret) {
    //try {
        if (startCaret && endCaret) {
            var rightOrder = startCaret.compareBoundaryPoints(Range.START_TO_END, endCaret) <= 0;
            if (rightOrder) {
                android.selection.selectionStartRange = startCaret;
                android.selection.selectionEndRange = endCaret;
            }
            else {
                startCaret = android.selection.selectionStartRange;
                endCaret = android.selection.selectionEndRange;
            }
            var doc = android.selection.getDocument();
            var range = doc.createRange();
            range.setStart(startCaret.startContainer, startCaret.startOffset);
            range.setEnd(endCaret.startContainer, endCaret.startOffset);
            android.selection.clearSelection();
            //var selection = window.getSelection();
            var selection = doc.getSelection();
            selection.addRange(range);
            android.selection.selectionChanged(rightOrder);
        }
        else {
            android.selection.selectionStartRange = startCaret;
            android.selection.selectionEndRange = endCaret;
            android.selection.selectionChanged(false);
        }
//    }
//    catch (e) {
//        window.TextSelection.jsError(e);
//    }
};
